# -*- coding: utf-8 -*-
## GrufSpaces
## Group environments for elaborating and exchanging information
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from zope.interface import implements
try:
    from Products.LinguaPlone.public import *
except ImportError:
    # No multilingual support
    from Products.Archetypes.public import *
from Products.ATContentTypes.content.folder import ATFolder, ATFolderSchema
from Products.GrufSpaces.config import PROJECTNAME
from Products.GrufSpaces.interface import IGroupSpace
from Products.ATContentTypes.content import schemata
from collective.groupspace.roles.interfaces import ILocalGroupSpacePASRoles
from collective.groupspace.workflow.interfaces import ILocalGroupSpaceWorkflow

GroupSpaceSchema = ATFolderSchema.copy()
schemata.finalizeATCTSchema(GroupSpaceSchema, moveDiscussion=False)

class GroupSpace(ATFolder):
    """GroupSpace container implementing the IGroupSpace interface.

       It implements the ILocalGroupSpacePASRoles so that local PAS roles 
       can be assigned dynamically in the roles view.
 
       In addition, the ILocalGroupSpaceWorkflow is supported, so that when
       a GroupSpace is created, a special local workflow policy is added that
       enforces the use of a default workflow.
    """
    implements(IGroupSpace, 
               ILocalGroupSpacePASRoles,
               ILocalGroupSpaceWorkflow)
    
    meta_type = 'GroupSpace'
    schema =  GroupSpaceSchema
    
    # The following attributes need to be initialized in order to support the
    # ILocalGroupSpacePASRoles interface    
    user_roles = None
    group_roles = None

registerType(GroupSpace, PROJECTNAME)

